> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://mailchimp.com/developer/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://mailchimp.com/developer/_mcp/server.

# Batch add or remove members

POST https://api.mailchimp.com/3.0/lists/{list_id}/segments/{segment_id}
Content-Type: application/json

Batch add/remove list members to static segment

Reference: https://mailchimp.com/developer/marketing/api/lists/batch-add-or-remove-members

## Authentication

- `Authorization` header (bearer token, required) — Authorization using a Mailchimp API key (a.k.a. Bearer token)
- `Authorization` header (bearer token, required) — Authorization using OAuth

## Request

### Path parameters

- `list_id` (string, required) — The unique ID for the list.
- `segment_id` (string, required) — The unique id for the segment.

### Body (application/json)

This endpoint expects an object.

- `members_to_add` (list of string, optional) — An array of emails to be used for a static segment. Any emails provided that are not present on the list will be ignored. A maximum of 500 members can be sent.
- `members_to_remove` (list of string, optional) — An array of emails to be used for a static segment. Any emails provided that are not present on the list will be ignored. A maximum of 500 members can be sent.

## Response

### 200

- `_links` (list of 30ListsListIdSegmentsSegmentIdPostResponsesContentApplicationJsonSchemaLinksItems, optional) — A list of link types and descriptions for the API schema documents.
- `error_count` (integer, optional) — The total number of items matching the query, irrespective of pagination.
- `errors` (list of 30ListsListIdSegmentsSegmentIdPostResponsesContentApplicationJsonSchemaErrorsItems, optional) — An array of objects, each representing an array of email addresses that could not be added to the segment or removed and an error message providing more details.
- `members_added` (list of ListsPost, optional) — An array of objects, each representing a new member that was added to the static segment.
- `members_removed` (list of ListsPost, optional) — An array of objects, each representing an existing list member that got deleted from the static segment.
- `total_added` (integer, optional) — The total number of items matching the query, irrespective of pagination.
- `total_removed` (integer, optional) — The total number of items matching the query, irrespective of pagination.

## Types

### 30ListsListIdSegmentsSegmentIdPostResponsesContentApplicationJsonSchemaLinksItems

This object represents a link from the resource where it is found to another resource or action that may be performed.

- `href` (string, optional) — This property contains a fully-qualified URL that can be called to retrieve the linked resource or perform the linked action.
- `method` (enum, optional) — The HTTP method that should be used when accessing the URL defined in 'href'.
  - Allowed values: `GET`, `POST`, `PUT`, `PATCH`, `DELETE`, `OPTIONS`, `HEAD`
- `rel` (string, optional) — As with an HTML 'rel' attribute, this describes the type of link.
- `schema` (string, optional) — For HTTP methods that can receive bodies (POST and PUT), this is a URL representing the schema that the body should conform to.
- `targetSchema` (string, optional) — For GETs, this is a URL representing the schema that the response should conform to.

### 30ListsListIdSegmentsSegmentIdPostResponsesContentApplicationJsonSchemaErrorsItems

- `email_addresses` (list of string, optional) — Email addresses added to the static segment or removed
- `error` (string, optional) — The error message indicating why the email addresses could not be added or updated.

### ListsPost

Individuals who are currently or have been previously subscribed to this list, including members who have bounced or unsubscribed.

- `_links` (list of ListsPostLinksItems, optional) — A list of link types and descriptions for the API schema documents.
- `contact_id` (string, optional) — A unique ID for the contact record.
- `email_address` (string, optional) — Email address for a subscriber.
- `email_client` (string, optional) — The list member's email client.
- `email_type` (string, optional) — Type of email this member asked to get ('html' or 'text').
- `id` (string, optional) — The MD5 hash of the lowercase version of the list member's email address.
- `interests` (map from string to boolean, optional) — The key of this object's properties is the ID of the interest in question.
- `ip_opt` (string, optional) — The IP address the subscriber used to confirm their opt-in status.
- `ip_signup` (string, optional) — IP address the subscriber signed up from.
- `language` (string, optional) — If set/detected, the [subscriber's language](https://mailchimp.com/help/view-and-edit-contact-languages/).
- `last_changed` (datetime, optional) — The date and time the member's info was last changed in ISO 8601 format.
- `last_note` (ListsPostLastNote, optional) — The most recent Note added about this member.
- `list_id` (string, optional) — The list id.
- `location` (ListsPostLocation, optional) — Subscriber location information.
- `member_rating` (integer, optional) — Star rating for this member, between 1 and 5.
- `merge_fields` (map from string to any, optional) — An individual merge var and value for a member.
- `stats` (ListsPostStats, optional) — Open and click rates for this subscriber.
- `status` (enum, optional) — Subscriber's current status.
  - Allowed values: `subscribed`, `unsubscribed`, `cleaned`, `pending`, `transactional`
- `tags` (list of ListsPostTagsItems, optional) — The tags applied to this member.
- `tags_count` (integer, optional) — The number of tags applied to this member.
- `timestamp_opt` (datetime, optional) — The date and time the subscriber confirmed their opt-in status in ISO 8601 format.
- `timestamp_signup` (datetime, optional) — The date and time the subscriber signed up for the list in ISO 8601 format.
- `unique_email_id` (string, optional) — An identifier for the address across all of Mailchimp.
- `vip` (boolean, optional) — [VIP status](https://mailchimp.com/help/designate-and-send-to-vip-contacts/) for subscriber.

### ListsPostLinksItems

This object represents a link from the resource where it is found to another resource or action that may be performed.

- `href` (string, optional) — This property contains a fully-qualified URL that can be called to retrieve the linked resource or perform the linked action.
- `method` (enum, optional) — The HTTP method that should be used when accessing the URL defined in 'href'.
  - Allowed values: `GET`, `POST`, `PUT`, `PATCH`, `DELETE`, `OPTIONS`, `HEAD`
- `rel` (string, optional) — As with an HTML 'rel' attribute, this describes the type of link.
- `schema` (string, optional) — For HTTP methods that can receive bodies (POST and PUT), this is a URL representing the schema that the body should conform to.
- `targetSchema` (string, optional) — For GETs, this is a URL representing the schema that the response should conform to.

### ListsPostLastNote

The most recent Note added about this member.

- `created_at` (datetime, optional) — The date and time the note was created in ISO 8601 format.
- `created_by` (string, optional) — The author of the note.
- `note` (string, optional) — The content of the note.
- `note_id` (integer, optional) — The note id.

### ListsPostLocation

Subscriber location information.

- `country_code` (string, optional) — The unique code for the location country.
- `dstoff` (integer, optional) — The offset for timezones where daylight saving time is observed.
- `gmtoff` (integer, optional) — The time difference in hours from GMT.
- `latitude` (double, optional) — The location latitude.
- `longitude` (double, optional) — The location longitude.
- `timezone` (string, optional) — The timezone for the location.

### ListsPostStats

Open and click rates for this subscriber.

- `avg_click_rate` (double, optional) — A subscriber's average clickthrough rate.
- `avg_open_rate` (double, optional) — A subscriber's average open rate.

### ListsPostTagsItems

- `id` (integer, optional) — The tag id.
- `name` (string, optional) — The name of the tag

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "_links": [
    {
      "href": "string",
      "method": "GET",
      "rel": "string",
      "schema": "string",
      "targetSchema": "string"
    }
  ],
  "error_count": 42,
  "errors": [
    {
      "email_addresses": [
        "string"
      ],
      "error": "string"
    }
  ],
  "members_added": [
    {
      "_links": [
        {
          "href": "string",
          "method": "GET",
          "rel": "string",
          "schema": "string",
          "targetSchema": "string"
        }
      ],
      "contact_id": "string",
      "email_address": "string",
      "email_client": "string",
      "email_type": "string",
      "id": "string",
      "interests": {},
      "ip_opt": "string",
      "ip_signup": "string",
      "language": "string",
      "last_changed": "2024-01-15T09:30:00Z",
      "last_note": {
        "created_at": "2024-01-15T09:30:00Z",
        "created_by": "string",
        "note": "string",
        "note_id": 1
      },
      "list_id": "string",
      "location": {
        "country_code": "string",
        "dstoff": 1,
        "gmtoff": 1,
        "latitude": 1.1,
        "longitude": 1.1,
        "timezone": "string"
      },
      "member_rating": 1,
      "merge_fields": {},
      "stats": {
        "avg_click_rate": 1.1,
        "avg_open_rate": 1.1
      },
      "status": "subscribed",
      "tags": [
        {
          "id": 1,
          "name": "string"
        }
      ],
      "tags_count": 1,
      "timestamp_opt": "2024-01-15T09:30:00Z",
      "timestamp_signup": "2024-01-15T09:30:00Z",
      "unique_email_id": "string",
      "vip": true
    }
  ],
  "members_removed": [
    {
      "_links": [
        {
          "href": "string",
          "method": "GET",
          "rel": "string",
          "schema": "string",
          "targetSchema": "string"
        }
      ],
      "contact_id": "string",
      "email_address": "string",
      "email_client": "string",
      "email_type": "string",
      "id": "string",
      "interests": {},
      "ip_opt": "string",
      "ip_signup": "string",
      "language": "string",
      "last_changed": "2024-01-15T09:30:00Z",
      "last_note": {
        "created_at": "2024-01-15T09:30:00Z",
        "created_by": "string",
        "note": "string",
        "note_id": 1
      },
      "list_id": "string",
      "location": {
        "country_code": "string",
        "dstoff": 1,
        "gmtoff": 1,
        "latitude": 1.1,
        "longitude": 1.1,
        "timezone": "string"
      },
      "member_rating": 1,
      "merge_fields": {},
      "stats": {
        "avg_click_rate": 1.1,
        "avg_open_rate": 1.1
      },
      "status": "subscribed",
      "tags": [
        {
          "id": 1,
          "name": "string"
        }
      ],
      "tags_count": 1,
      "timestamp_opt": "2024-01-15T09:30:00Z",
      "timestamp_signup": "2024-01-15T09:30:00Z",
      "unique_email_id": "string",
      "vip": true
    }
  ],
  "total_added": 42,
  "total_removed": 42
}
```

**SDK Code**

```python
import requests

url = "https://api.mailchimp.com/3.0/lists/list_id/segments/segment_id"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.mailchimp.com/3.0/lists/list_id/segments/segment_id';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.mailchimp.com/3.0/lists/list_id/segments/segment_id"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.mailchimp.com/3.0/lists/list_id/segments/segment_id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.mailchimp.com/3.0/lists/list_id/segments/segment_id")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.mailchimp.com/3.0/lists/list_id/segments/segment_id', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.mailchimp.com/3.0/lists/list_id/segments/segment_id");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.mailchimp.com/3.0/lists/list_id/segments/segment_id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```